import { launch } from 'effector';
import { defer } from './promise';
import { assign, own } from './tools';
export const patchInstance = (instance, { cancelled, cancel }) => {
    assign(instance, { cancelled, cancel });
    own(instance, [cancelled, cancel]);
    instance.create = (paramsOrConfig, _, [strategyOrConfig]) => {
        const config = (paramsOrConfig && (paramsOrConfig.strategy || paramsOrConfig.timeout)
            ? paramsOrConfig
            : strategyOrConfig && (strategyOrConfig.strategy || strategyOrConfig.timeout)
                ? strategyOrConfig
                : { strategy: strategyOrConfig });
        const req = defer();
        launch(instance, {
            params: config === paramsOrConfig ? config.params : paramsOrConfig,
            args: {
                strategy: config.strategy,
                timeout: config.timeout,
            },
            req,
        });
        return req.req;
    };
};
